(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/router')) :
    typeof define === 'function' && define.amd ? define(['exports', '@angular/core', '@angular/router'], factory) :
    (factory((global.ng2-page-transition = global.ng2-page-transition || {}),global.ng.core,global.ng.router));
}(this, (function (exports,_angular_core,_angular_router) { 'use strict';

function defaultPageTransition() {
    return fadeOutAndIn();
}
function fadeOutAndIn() {
    return _angular_core.trigger('ng2ElementState', [
        _angular_core.state('leave', _angular_core.style({
            opacity: 0.3,
        })),
        _angular_core.state('out', _angular_core.style({
            opacity: 0,
        })),
        _angular_core.state('enter', _angular_core.style({
            opacity: 1,
        })),
        _angular_core.transition('* => enter', _angular_core.animate('0.5s ease-in')),
        _angular_core.transition('* => leave', _angular_core.animate('0.2s ease-out')),
        _angular_core.transition('* => out', _angular_core.animate('0ms'))
    ]);
}

var Ng2PageTransitionComponent = (function () {
    function Ng2PageTransitionComponent(router) {
        var _this = this;
        this.router = router;
        this.scrollTop = true;
        this.onlyOnRoutes = [""];
        this.animation = {
            state: "leave",
            custom: false,
            enterDelay: 0
        };
        this.animation.state = "leave";
        router.events.subscribe(function (event) {
            for (var i = 0; i < _this.onlyOnRoutes.length; i++) {
                if (event.url && event.url.indexOf(_this.onlyOnRoutes[i]) > -1) {
                    if (event instanceof _angular_router.NavigationStart) {
                        _this.animation.state = "leave";
                        _this.delayPromise = new Promise(function (resolve, reject) {
                            window.setTimeout(function () {
                                resolve(true);
                            }, _this.animation.enterDelay);
                        });
                    }
                    else if (event instanceof _angular_router.NavigationEnd || event instanceof _angular_router.NavigationCancel) {
                        if (typeof _this.delayPromise !== "undefined") {
                            _this.delayPromise.then(function () {
                                _this.animation.state = "out";
                                if (_this.scrollTop) {
                                    window.scrollTo(0, 0);
                                }
                                setTimeout(function () {
                                    _this.animation.state = "enter";
                                }, 0);
                            });
                        }
                        else {
                            _this.animation.state = "out";
                            if (_this.scrollTop) {
                                window.scrollTo(0, 0);
                            }
                            setTimeout(function () {
                                _this.animation.state = "enter";
                            }, 0);
                        }
                    }
                    return;
                }
            }
        });
    }
    Ng2PageTransitionComponent.decorators = [
        { type: _angular_core.Component, args: [{
                    selector: 'ng2-page-transition',
                    template: '<div [@ng2ElementState]="animation.custom || animation.state"><ng-content></ng-content></div>',
                    animations: [defaultPageTransition()],
                },] },
    ];
    /** @nocollapse */
    Ng2PageTransitionComponent.ctorParameters = function () { return [
        { type: _angular_router.Router, },
    ]; };
    Ng2PageTransitionComponent.propDecorators = {
        'scrollTop': [{ type: _angular_core.Input },],
        'onlyOnRoutes': [{ type: _angular_core.Input },],
        'animation': [{ type: _angular_core.Input },],
    };
    return Ng2PageTransitionComponent;
}());

var Ng2PageTransitionModule = (function () {
    function Ng2PageTransitionModule() {
    }
    Ng2PageTransitionModule.decorators = [
        { type: _angular_core.NgModule, args: [{
                    declarations: [Ng2PageTransitionComponent],
                    exports: [Ng2PageTransitionComponent]
                },] },
    ];
    /** @nocollapse */
    Ng2PageTransitionModule.ctorParameters = function () { return []; };
    return Ng2PageTransitionModule;
}());

exports.Ng2PageTransitionComponent = Ng2PageTransitionComponent;
exports.Ng2PageTransitionModule = Ng2PageTransitionModule;
exports.defaultPageTransition = defaultPageTransition;
exports.fadeOutAndIn = fadeOutAndIn;

Object.defineProperty(exports, '__esModule', { value: true });

})));
