import { Component, Input } from '@angular/core';
import { Router, NavigationStart, NavigationEnd, NavigationCancel } from '@angular/router';
import { defaultPageTransition } from './default-transition.animation';
export var Ng2PageTransitionComponent = (function () {
    function Ng2PageTransitionComponent(router) {
        var _this = this;
        this.router = router;
        this.scrollTop = true;
        this.onlyOnRoutes = [""];
        this.animation = {
            state: "leave",
            custom: false,
            enterDelay: 0
        };
        this.animation.state = "leave";
        router.events.subscribe(function (event) {
            for (var i = 0; i < _this.onlyOnRoutes.length; i++) {
                if (event.url && event.url.indexOf(_this.onlyOnRoutes[i]) > -1) {
                    if (event instanceof NavigationStart) {
                        _this.animation.state = "leave";
                        _this.delayPromise = new Promise(function (resolve, reject) {
                            window.setTimeout(function () {
                                resolve(true);
                            }, _this.animation.enterDelay);
                        });
                    }
                    else if (event instanceof NavigationEnd || event instanceof NavigationCancel) {
                        if (typeof _this.delayPromise !== "undefined") {
                            _this.delayPromise.then(function () {
                                _this.animation.state = "out";
                                if (_this.scrollTop) {
                                    window.scrollTo(0, 0);
                                }
                                setTimeout(function () {
                                    _this.animation.state = "enter";
                                }, 0);
                            });
                        }
                        else {
                            _this.animation.state = "out";
                            if (_this.scrollTop) {
                                window.scrollTo(0, 0);
                            }
                            setTimeout(function () {
                                _this.animation.state = "enter";
                            }, 0);
                        }
                    }
                    return;
                }
            }
        });
    }
    Ng2PageTransitionComponent.decorators = [
        { type: Component, args: [{
                    selector: 'ng2-page-transition',
                    template: '<div [@ng2ElementState]="animation.custom || animation.state"><ng-content></ng-content></div>',
                    animations: [defaultPageTransition()],
                },] },
    ];
    /** @nocollapse */
    Ng2PageTransitionComponent.ctorParameters = function () { return [
        { type: Router, },
    ]; };
    Ng2PageTransitionComponent.propDecorators = {
        'scrollTop': [{ type: Input },],
        'onlyOnRoutes': [{ type: Input },],
        'animation': [{ type: Input },],
    };
    return Ng2PageTransitionComponent;
}());
//# sourceMappingURL=ng2-page-transition.component.js.map